#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<float.h>

#define maxchars 500000
#define maxmacro 10000
#define maxline  1000

char listing = 0;

FILE *infile;
FILE *outfile;

char input[maxchars];
char *inputP;
char output[maxchars];
char *outputP;

//char line[maxline];
char *line;
char qline[maxline];
int linenumber;
char string;
char name;
char keyword;
char label;
char constant;
char variable;
int variable0;
int variables;
char quote;
int i, j, k;
char phrase1[maxline];
char phrase2[maxline];
char phrase3[maxline];
char *phrase4;
char word1[maxline];
char word2[maxline];
char word3[maxline];
char targetlabel[maxline];
char *wordP;
char defineda[maxchars];
char *definedP;
char *definedv[maxmacro];
int definedc;
char macro[maxchars];
char *macroP;
char *macrov[maxmacro];
char *macroquote[maxmacro];
int macroc;
char *macroiP;
int macroi;
char labeling;
char dimming;
char defining;
char atflag;
int datac;
int labels;
int labelsdone;
int constants;
char *fromP;
char *toP;
int screenc;
int xrefc = 0;

char *ubn_itoa(int number, char *charP) {
  int i=0;
  int divisor=100000;
  int quotient;
  char some=0;
  while (divisor) {
    quotient = number/divisor;
    if (some || quotient || divisor==1) {
      some = 1;
      charP[i++] = quotient+'0';
    }
    number = number-quotient*divisor;
    divisor = divisor/10;
  }
  charP[i] = 0;
  return charP;
}

char *xref[] = {
  " %d  %s %s\\n\", UBN_XRF_LINE_LABEL, LN_$, VLSTRING$",
  " %d  %s %s\\n\", UBN_XRF_VARIABLE, LN_$, VLSTRING$",
  " %d  %s %s\\n\", UBN_XRF_VARIABLE, LN_$, VLSTRING$",
  " %d  %s %s\\n\", UBN_XRF_KEYWORD_REFERENCE, LN_$, VLSTRING$",
  " %d  %s %s\\n\", UBN_XRF_LINE_REFERENCE, LN_$, LINE_LABELS$[LINE_LABEL_COUNTER][LINE_LABELS_NUMBER]",
  " %d  %s %s\\n\", UBN_XRF_VARIABLE_REFERENCE, LN_$, VLSTRING$",
  "skip",
  ""
};

char *screenv[] = {
  "q%d %s\\n\", LINE_NUMBER, IN_LINE$",
  "%d %d at %d\\n\", LINE_NUMBER, IN_LINE_CH, IN_LINE_CHAR_COUNTER",
  "%d Too many variables\", LINE_NUMBER",
  "%d Missing end quote - %s\\n\", LINE_NUMBER, QSTRING$", 
  "%d '$' should not be used in labels - %s\\n\", LINE_NUMBER, VLSTRING$",
  "%d Too many labels\", LINE_NUMBER",
  "%d Duplicate line label  - %s\\n\", LINE_NUMBER, VLSTRING$",
  "%d Too many variables\", LINE_NUMBER",
  "%d Invalid Octal Number - %s\\n\",LINE_NUMBER, HO_STRING$",
  "%d '&' not followed by 'H' or 'O' - %s\\n\", LINE_NUMBER, HO_STRING$",
  "l%d %s\\n\", LINE_NUMBER, IN_LINE$",
  "qPass %d; %d lines\\n\", PASS, LINE_COUNT",
  "q ---------PASS 2 STARTING------\\n\"",
  "q%s\\n\", UBN_TITLE$",
  "qErrs %d, Warns %d. Lines %d, Labels %d, Vars %d\\n\", ERRORS, WARNINGS, LINE_COUNT, LINE_LABEL_COUNT, VARIABLE_NAMES_COUNT",
  ""
};

char *keywords[] = {
  "REM",
  "ATTR",
  "AUDIO",
  "BACKUP",
  "CIRCLE",
  "CLEAR",
  "CLOAD",
  "CLOADM",
  "CLOSE",
  "CLS",
  "COLOR",
  "CONSTANT",
  "CONT",
  "COPY",
  "CSAVE",
  "CSAVEM",
  "DATA",
  "DEF",
  "DEFUSR",
  "DEL",
  "DIM",
  "DIR",
  "DLOAD",
  "DRAW",
  "DRIVE",
  "DSKI$",
  "DSKINI",
  "DSKO$",
  "EDIT",
  "ELSE",
  "END",
  "EXEC",
  "FIELD",
  "FILES",
  "FN",
  "FOR",
  "GET",
  "GOSUB",
  "GOTO",
  "HBUFF",
  "HCIRCLE",
  "HCLS",
  "HCOLOR",
  "HDRAW",
  "HGET",
  "HLINE",
  "HPAINT",
  "HPRINT",
  "HPUT",
  "HRESET",
  "HSCREEN",
  "HSET",
  "HSTAT",
  "IF",
  "INPUT",
  "KILL",
  "LET",
  "LINE",
  "LIST",
  "LLIST",
  "LOCATE",
  "LPOKE",
  "LOAD",
  "LOADM",
  "LSET",
  "MERGE",
  "MOTOR",
  "NEW",
  "NEXT",
  "OLD",
  "ON",
  "OPEN",
  "PAINT",
  "PALETTE",
  "PAUSE",
  "PCLEAR",
  "PCLS",
  "PCOPY",
  "PLAY",
  "PMODE",
  "POKE",
  "PRESET",
  "PRINT",
  "PSET",
  "PUT",
  "READ",
  "RENAME",
  "RENUM",
  "RESET",
  "RSET",
  "RESTORE",
  "RESUME",
  "RETURN",
  "RUN",
  "SAVE",
  "SAVEM",
  "SCREEN",
  "SET",
  "SKIPF",
  "SOUND",
  "STOP",
  "TO",
  "TROFF",
  "TRON",
  "WIDTH",
  "WRITE",
  "UNLOAD",
  "VERIFY",
  "MEM",
  "TIMER",
  "AND",
  "NOT",
  "OR",
  "LSE",
  "STEP",
  "FREE",
  "AS",
  "BRK",
  "ERR",
  "CMP",
  "RGB",
  "USING",
  "ERROR",
  "FREE",
  "OFF",
  "TAB",
  "USING",
  "THEN",
  "TO",
  "?",
  "AS",
  "OR",
  "PI",

/* Functions, keywords that require next character to be an open parentheses */

  "ABS",
  "ASC",
  "ATN",
  "BUTTON",
  "CHR$",
  "COS",
  "CVN",
  "EOF",
  "ERLIN",
  "ERNO",
  "EXP",
  "FIX",
  "HEX$",
  "HPOINT",
  "INKEY$",
  "INSTR",
  "INT",
  "JOYSTK",
  "LEFT$",
  "LEN",
  "LOC",
  "LOF",
  "LOG",
  "LPEEK",
  "MID$",
  "MKN$",
  "PEEK",
  "POINT",
  "POS",
  "PPOINT",
  "RIGHT$",
  "RND",
  "SGN",
  "SIN",
  "STRING$",
  "STR$",
  "SQR",
  "TAN",
  "USR",
  "VAL",
  "VARPTR",
  ""
};


// Illegal Two Character Variable Table
// NOTE "PI" is a variable that is NOT replaced

char *illegal[] = {
  "BF",
  "AS",
  "FN",
  "IF",
  "ON",
  "OR",
  "PI",
  "TO",
  ""
};

int error(char *mesg) {
  printf("%s\n%d %s", inputP, linenumber, mesg);
  exit(0);
}

char *skip2colon(char *lineP) {
  while (*lineP && *lineP!=':')  lineP++;
  return lineP;
}

char *copy2colon(char *lineP) {
  while (*lineP && *lineP!=':')  lineP++;
  return lineP;
}

char islabelchar(char intch) {
  if (intch=='_' || intch=='~'
      || (intch>='A' && intch<='Z')
      || (intch>='a' && intch<='z')
      || (intch>='0' && intch<='9'))  return 1;
  return 0;
}

char isin(char *word, char **table) {
  int i=0;
  while (table[i][0]) {
    if (!strcmp(word, table[i]))  break;
    i++;
  }
  if (table[i][0])  return 1;
  return  0;
}

char *copyword(char *wordP, char *lineP) {
  while (*wordP)
    *lineP++ = *wordP++;
  *lineP = 0;
  return lineP;
}

void fixmacro(char *inP) {
  char *beginP;
  char *endP;
  int length;
  beginP = inP;
  length = strlen(inP);
  for (i=0; i<length-4; i++) {
    if (inP[i]==' ' && (inP[i+1]=='x' || inP[i+1]=='X')) {
      wordP = word1;
      endP = inP+i+1;
      for (i=i+2; i<length; i++) {
        if (inP[i]==' ' || inP[i]=='$')  break;
        if (inP[i]>='A' && inP[i]<='Z' ||
            inP[i]>='a' && inP[i]<='z' ||
            inP[i]=='_' || inP[i]=='~')
          *wordP++ = inP[i];
        else break;
      }
      if (i<length) {
        if (inP[i]==' ')  i--;
        else  if (inP[i]=='$') {
          *wordP++ = '$';
          *wordP = 0;
          for (j=0; j<macroc; j=j+2) {
            if (!strcmp(macrov[j], word1)) {
              if (j==macroc-2)
                error("macro recursion");
              *endP =0;
              macroP = strcat(macroP, beginP)+strlen(beginP);
              macroP = strcat(macroP, macrov[j+1])+strlen(macrov[j+1]);
              beginP = inP+i+1;
            }
          }
        }
      }
    }
  }
  char *tempP;
  tempP = macroP;
  macroP = strcat(macroP, beginP)+strlen(beginP);
  *++macroP = 0;
}

char *getword(char *wordP, char *lineP) {
  char *word;
  int i;
  char dot=0;
  *wordP = 0;
  while (*lineP==' ')  lineP++;
  if (!*lineP)  return  lineP;
  word = wordP;
  if (*lineP=='"') {
    *wordP++ = *lineP++;
    while (*lineP && *lineP!='"')  *wordP++ = *lineP++;
    if (*lineP++!='"')  error("unmatched \"");
    *wordP = 0;
    fixmacro(word+1);
    strcat(wordP, "\"");
    string = 1;
    constant = 1;
    keyword = 0;
    name = 0;
    label = 0;
    variable = 0;
    return lineP;
  }
  if (islabelchar(*lineP))  name=1;
  if (*lineP>='0' && *lineP<='9' || *lineP=='.') {
    name=0;
    constant = 1;
    keyword = 0;
  }
  else  constant=0;
  while (islabelchar(*lineP) || *lineP=='.') {
    if (*lineP=='.')  dot=1;
    else if ((*lineP<'0' || *lineP>'9') && !name)  constant=0;
    if (!name && *lineP=='_')  error ("stray _");
    if (!name && *lineP=='~')  error ("stray ~");
    *wordP++ = *lineP++;
    *wordP = 0;
  }
  if (constant && word!=wordP) {
    if (!dot)  strcat(word, ".0");
    return lineP;
  }
  if (*lineP=='$') {
    if (word==wordP || !name)  error("stray $");
    *wordP++ = *lineP++;
    string = 1;
    constant = 0;
  }
  else  string = 0;
  if (word==wordP) {
    name = 0;
    constant = 0;
    keyword = 0;
    if (*lineP=='<' && *(lineP+1)=='=' ||
        *lineP=='>' && *(lineP+1)=='=' ||
        *lineP=='<' && *(lineP+1)=='>')
      *wordP++ = *lineP++;
    *wordP++ = *lineP++;
    *wordP = 0;
    return lineP;
  }
  *wordP = 0;
  label = 0;
  name = 1;
  keyword = isin(word, keywords);
  if (keyword) {
    variable = 0;
    return lineP;
  }
  i = 0;
  constant = 0;
  variable = 0;
  strcpy(targetlabel, word);
  strcat(targetlabel, "l_ubn");
  i=0; while (definedv[i][0] && strcmp(word, definedv[i])
       && strcmp(targetlabel, definedv[i]))  i++;
  if (labeling || (i>=constants && i< labels))  strcat(word, "l_ubn");
  if ((defining || dimming) && i>=labels) {
    if (string) {
      *(word+strlen(word)-1) = 0;
      strcat(word, "_s_ubn");
    }
    else  strcat(word, "_f_ubn");
  }
  i=0; while (definedv[i][0] && strcmp(word, definedv[i]))  i++;
  variable = 0;
  if (i<labels)  label = 1;
  else if (!defining && !dimming || i<constants)  constant=1;
  else variable = 1;
  if (i>=definedc) {
    definedv[definedc++] = definedP;
    definedv[definedc] = "";
    definedP = copyword(word, definedP);
    *definedP++ = 0;
    if (defining) {
      if (string)  fprintf(outfile, "char %s[300];\n", word);
      else  fprintf(outfile, "double %s;\n", word);
    }
  }
  return lineP;
}

char *copylabel(FILE *outfile, char *lineP) {
  char word[1000];
  lineP = getword(word, lineP);
  fprintf(outfile, word);
  return lineP;
}

void geterr(
    char *destack, char *tempstack, char *word, char *charP,char *mesg) {
  printf("%s!%s\n%s\n%s!%s\n", destack, tempstack, phrase4, word, charP);
  error(mesg);
}

void checknumber(char **destackP, char **stackP,
    char *destack, char *tempstack, char *word, char *charP) {
  if (**stackP=='N' || **stackP=='F' || **stackP=='L') {
    *destackP = strcat(*destackP, "N")+1;
    **stackP = 0;
    *stackP = *stackP-1;
  }
  else  geterr(destack, tempstack, word, charP, "I wanted a string");
}

void checkstring(char **destackP, char **stackP,
    char* destack, char* tempstack, char *word, char *charP) {
  if (**stackP=='S' || **stackP=='L' || **stackP=='F') {
    *destackP = strcat(*destackP, *stackP)+1;
    **stackP = 0;
    *stackP = *stackP-1;
  }
  else  geterr(destack, tempstack, word, charP, "I wanted a number");
}

void checklval(char **destackP, char **stackP,
    char* destack, char* tempstack, char *word, char *charP) {
  if (**stackP=='L')
    geterr(destack, tempstack, word, charP, "illegal l-val");
}

void checkleftparen(char **destackP, char **stackP,
    char *destack, char *tempstack, char *word, char **charP) {
  *charP = getword(word, *charP);
  if (!strcmp(word, "(")) {
    strcat(phrase4, "(");
    *destackP = strcat(*destackP, "(")+1;
  }
  else  geterr(destack, tempstack, word, *charP, "I wanted a (");
}

char *partphrase(char *lval, char *phraseP, char *lineP) {
  char *phrase;
  char stringtype;
  char *charP;
  char *tempP;
  char temphrase[1000];
  char word[1000];
  char tempstack[1000];
  char *stackP;
  char destack[1000];
  char phrasestring;
  char *destackP;
  stackP = tempstack;
  destackP = destack;
  strcpy(stackP, "E" );
  stackP = strcat(stackP, lval)+1;
  strcpy(destackP, "E");
  phrase = phraseP;
  *phraseP = 0;
  if (!*lineP)  error("empty phrase");
  charP = lineP;
  tempP = temphrase;
  charP = getword(word, lineP);
  if (constant)  checklval(&destackP, &stackP, destack, tempstack, word, charP);
  stringtype = string;
  do {
    if (!strcmp(word, "(")) {
      strcat(phraseP, "[index__ubn(");
      destackP = strcat(destackP, "(")+1;
      stackP = strcat(stackP, "]N")+2;
    }
    else if (!strcmp(word, "MID$"))  {
      checklval(&destackP, &stackP, destack, tempstack, word, charP);
      checkstring(&destackP, &stackP, destack, tempstack, word, charP);
      strcat(phraseP, "mid__ubn");
      checkleftparen(&destackP, &stackP, destack, tempstack, word, &charP);
      stackP = strcat(stackP, "MN,S")+4;
    }
    else if (!strcmp(word, "LEFT$"))  {
      checklval(&destackP, &stackP, destack, tempstack, word, charP);
      checkstring(&destackP, &stackP, destack, tempstack, word, charP);
      strcat(phraseP, "left__ubn");
      checkleftparen(&destackP, &stackP, destack, tempstack, word, &charP);
      stackP = strcat(stackP, ")N,S")+4;
    }
    else if (!strcmp(word, "RIGHT$"))  {
      checklval(&destackP, &stackP, destack, tempstack, word, charP);
      checkstring(&destackP, &stackP, destack, tempstack, word, charP);
      strcat(phraseP, "right__ubn");
      checkleftparen(&destackP, &stackP, destack, tempstack, word, &charP);
      stackP = strcat(stackP, ")N,S")+4;
    }
    else if (!strcmp(word, "INSTR"))  {
      checklval(&destackP, &stackP, destack, tempstack, word, charP);
      checknumber(&destackP, &stackP, destack, tempstack, word, charP);
      strcat(phraseP, "instr__ubn");
      stackP = strcat(stackP, "I")+1; /*instr*/
      checkleftparen(&destackP, &stackP, destack, tempstack, word, &charP);
    }
    else if (!strcmp(word, "-") || !strcmp(word, "+") ||
        !strcmp(word, "*") || !strcmp(word, "/")) {
      checklval(&destackP, &stackP, destack, tempstack, word, charP);
      strcat(phraseP, word);
      *destackP-- = 0;
      stackP = strcat(stackP, "N")+1;
    }
    else if (!strcmp(word, ",")) {
      if (*stackP==',') {
        *stackP-- = 0;
        *destackP-- = 0;
        strcat(phraseP, ",");
      }
      else if (*stackP=='M') { /*mid$*/
        strcat(phraseP, ",");
        *stackP-- = 0;
        *destackP-- = 0;
        stackP = strcat(stackP, ")N")+2;
      }
      else if (*stackP==']') {
        strcat(phraseP, ")][index__ubn(");
        *destackP-- = 0;
        stackP = strcat(stackP, "N")+1;
      }
      else  geterr(destack, tempstack, word, charP, "unexpected ,");
    }
    else if (!strcmp(word, ")")) {
      if (*stackP=='M') { /*mid*/
        strcat(phraseP, ",0)");
        *destackP--=0;
        *destackP--=0;
        *stackP-- = 0;
      }
      else if (*stackP==']') {
        strcat(phraseP, ")]");
        *destackP-- = 0;
        *destackP-- = 0;
        *stackP-- = 0;
      }
      else if (*stackP==')') {
        strcat(phraseP, ")");
        *destackP-- = 0;
        *destackP--=0;
        *stackP-- = 0;
      }
      else  geterr(destack, tempstack, word, charP, "unexpected )");
    }
    else if (!strcmp(word, "ASC")) {
      checklval(&destackP, &stackP, destack, tempstack, word, charP);
      checknumber(&destackP, &stackP, destack, tempstack, word, charP);
      strcat(phraseP, "asc__ubn");
      checkleftparen(&destackP, &stackP, destack, tempstack, word, &charP);
      stackP = strcat(stackP, ")S")+2;
    }
    else if (!strcmp(word, "LEN")) {
      checklval(&destackP, &stackP, destack, tempstack, word, charP);
      checknumber(&destackP, &stackP, destack, tempstack, word, charP);
      strcat(phraseP, "len__ubn");
      checkleftparen(&destackP, &stackP, destack, tempstack, word, &charP);
      stackP = strcat(stackP, ")S")+2;
    }
    else if (!strcmp(word, "CHR$")) {
      checklval(&destackP, &stackP, destack, tempstack, word, charP);
      checkstring(&destackP, &stackP, destack, tempstack, word, charP);
      strcat(phraseP, "chr__ubn");
      checkleftparen(&destackP, &stackP, destack, tempstack, word, &charP);
      stackP = strcat(stackP, ")N")+2;
    }
    else {
      if (keyword) {
        error("keyword in phrase");
      }
      else if (*stackP=='I') { /*instr*/
        *stackP-- = 0;
        if (string) {
          strcat(phraseP, "1,");
          stackP = strcat(stackP, ")S,S")+4;
          checkstring(&destackP, &stackP, destack, tempstack, word, charP);
        }
        else {
          stackP = strcat(stackP, ")S,S,N")+6;
          checknumber(&destackP, &stackP, destack, tempstack, word, charP);
        }
      }
      else if (*stackP==',')
        geterr(destack, tempstack, word, charP, "I was expecting a ,");
      else if (*stackP==')' || *stackP==']' || *stackP=='M')
        geterr(destack, tempstack, word, charP, "I was expecting a )");
      else if (string)
        checkstring(&destackP, &stackP, destack, tempstack, word, charP);
      else  checknumber(&destackP, &stackP, destack, tempstack, word, charP);
      strcat(phraseP, word);
    }
    lineP = charP;
    charP = getword(word, lineP);
  }
  while (*stackP!='E' || *word=='(' || *word=='+' ||
      *word=='-' || *word=='*' || *word=='/');
  if (strcmp(destack, "EN") && strcmp(destack, "EF") &&
        strcmp(destack, "EL") && strcmp(destack, "ES"))
    geterr(destack, tempstack, word, charP, "bad destack on exit");
  if (!strcmp(destack, "EN"))  string=0;
  else  string=1;
  return lineP;
}

char *getphrase(char *phraseP, char *lineP) {
  phrase4 = phraseP;
  return partphrase("F", phraseP, lineP);
}

char *lvalphrase(char *phraseP, char *lineP) {
  phrase4 = phraseP;
  return partphrase("L", phraseP, lineP);
}

char *stringphrase(char *phraseP, char *lineP) {
  phrase4 = phraseP;
  return partphrase("S", phraseP, lineP);
}

char *numberphrase(char *phraseP, char *lineP) {
  phrase4 = phraseP;
  return partphrase("N", phraseP, lineP);
}

char *bigphrase(char *lineP) {
  char *charP;
  char parens;
  char word[300];
  char phrase[300];
  if (!*lineP)  error("missing expression");
  charP = getword(word, lineP);
  if (!strcmp(word, ":"))  error("missing expression");
  parens = 0;
  do {
    char joiners[] = "()+-*/";
    for (i=0; i<strlen(joiners); i++)
      if (word[0]==joiners[i])  break;
    if (i<strlen(joiners)) {
      if (strlen(word)!=1) {
        printf("%s\n", word);
        error("syntax C");
      }
      fprintf(outfile, word);
      if (word2[0]=='(')  parens++;
      if (word2[0]==')')  parens--;
      lineP = charP;
    }
    else if (name || constant) {
      if (string)  error("string phrase");
      lineP=getphrase(phrase, lineP);
      fprintf(outfile, phrase);
    }
    else {
      printf("%s!%s\n", word, lineP);
      error("syntax D");
    }
    charP = getword(word, lineP);
  }
  while (word[0] && !keyword && strcmp(word, "=") &&
      strcmp(word, ":") && strcmp(word, ","));
  if (parens)  error("mismatched parens");
  return  lineP;
}

char *before[] = {
  "#include<stdio.h>",
  "#include<stdlib.h>",
  "#include<string.h>",
  "#include<curses.h>",
  "#include<limits.h>",
  "#include<float.h>",
  "",
  "#define fors__ubn 10000",
  "",
  "#define index__ubn(x) ((x)<-0.5 || (x)>=INT_MAX+0.5 ?\\",
  "ierr__ubn(\"index overflow\", line__ubn) : (int)((x)+0.5))",
  "",
  "#define round__ubn(x) ((x)<INT_MIN-0.5 || (x)>=INT_MAX+0.5 ? ierr__ubn(\\",
  "\"integer overflow\", line__ubn) : ((x)>=0?(int)((x)+0.5):(int)((x)-0.5)))",
  "",
  "char return__ubn[fors__ubn];",
  "char *returnP__ubn;",
  "char fora__ubn[fors__ubn];",
  "char for__ubn[fors__ubn];",
  "char *forP__ubn;",
  "char *tempP__ubn;",
  "int switcher__ubn;",
  "int line__ubn;",
  "int forvar__ubn;",
  "int back__ubn;",
  "float to__ubn[fors__ubn];",
  "float step__ubn[fors__ubn];",
  "float sf__ubn=0.0000001;",
  "int datac__ubn;",
  "int fuzz__ubn;",
  "float big__ubn;",
  "int i__ubn;",
  "float f__ubn;",
  "int P__ubn;",
  "char phrase__ubn[300];",
  "float dend__ubn;",
  "",
  "char chrs__ubn[256][2];",
  "",
  "FILE *bug;",
  "char tron=0;",
  "FILE *file__ubn[10];",
  "int eof__ubn[10];",
  "",
  "typedef struct string__ubn { char dummy__ubn[300]; } empty__ubn;",
  "",
  "int asc__ubn(char *string) {",
  "  return string[0];",
  "}",
  "",
  "char *chr__ubn(int val) {",
  "  return chrs__ubn[val];",
  "}",
  "",
  "int len__ubn(char *name) {",
  "  int i = 0;",
  "  while (name[i]) i++;",
  "  return i;",
  "}",
  "",
  "void error__ubn(char *mesg, int line) {",
  "  printf(\"%s in line %d\", mesg, line);",
  "  exit(0);",
  "}",
  "",
  "int ierr__ubn(char *mesg, int line) {",
  "  error__ubn(mesg, line__ubn);",
  "  return 0;",
  "}",
  "",
  "char *join__ubn(int linenumber, char *first, char *second) {",
  "  char *toP;",
  "  char *retval;",
  "  char *firstP = first;",
  "  char *secondP = second;",
  "  int i = 0;",
  "  char *mesg;",
  "  toP = malloc(sizeof(struct string__ubn));",
  "  retval = toP;",
  "  mesg = \"\";",
  "  if (first==second)  mesg = \"string order\";",
  "  while ((*toP++ = *firstP++))  i++;",
  "  while ((*toP++ = *secondP++))  if (i++>256)  break;",
  "  if (i>256) {",
  "    if (!mesg[0])  mesg = \"string overflow\";",
  "    printf(\"%d %s %s\\n%s\", linenumber, mesg, first, second);",
  "    exit(0);",
  "  }",
  "  return retval;",
  "}",
  "",
  "char *let__ubn(char *toP, char *fromP) {",
  "  char *retval;",
  "  retval = toP;",
  "  while ((*toP++=*fromP++));",
  "  *toP = 0;",
  "  return retval;",
  "}",
  "",
  "char *mid__ubn(char *fromP, int begin, int length) {",
  "  char *toP;",
  "  char *retval;",
  "  toP = malloc(sizeof(struct string__ubn));",
  "  retval = toP;",
  "  if (length>strlen(fromP)||!length) length=strlen(fromP);",
  "  if (begin>strlen(fromP)+1)  begin=strlen(fromP)+1;",
  "  fromP = fromP+begin-1;",
  "  while (length--&&*fromP)  *toP++=*fromP++;",
  "  *toP = 0;",
  "  return retval;",
  "}",
  "",
  "void lineinput__ubn(int fileno, char *lineP) {",
  "  if (fileno<0 || fileno>9)  error__ubn(\"bad file number\", line__ubn);",
  "  if (eof__ubn[fileno]==EOF)  error__ubn(\"input past end\", line__ubn);",
  "  eof__ubn[fileno] = fgetc(file__ubn[fileno]);",
  "  while (eof__ubn[fileno] && eof__ubn[fileno]!=EOF",
  "      && eof__ubn[fileno]!=10) {",
  "    *lineP++=eof__ubn[fileno];",
  "    eof__ubn[fileno] = fgetc(file__ubn[fileno]);",
  "  }",
  "  *lineP = 0;",
  "}",
  "",
  "char *left__ubn(char *fromP, int delta) {",
  "  char *toP;",
  "  int i;",
  "  toP = malloc(sizeof(struct string__ubn));",
  "  if (delta>strlen(fromP))  delta=strlen(fromP);",
  "  for (i=0; i<delta; i++)  toP[i]=fromP[i];",
  "  toP[i] = 0;",
  "  return toP;",
  "}",
  "",
  "char *right__ubn(char *charP, int delta) {",
  "  int start;",
  "  start = strlen(charP)-delta;",
  "  if (start<0)  start=0;",
  "  return charP+start;",
  "}",
  "",
  " instr__ubn(int start, char *target, char *arrow) {",
  "  int i, j;",
  "  if (start-1+strlen(arrow)>strlen(target))  return 0;",
  "  for (j=start-1; j<=strlen(target)-strlen(arrow); j++) {",
  "    i = 0;",
  "    if (target[j]==arrow[0])",
  "      for (i=0; i<strlen(arrow); i++)",
  "        if (arrow[i]!=target[j+i])  break;",
  "    if (i>=strlen(arrow))  break;",
  "  }",
  "  if (j>strlen(target)-strlen(arrow))  j=-1;",
  "  return  j+1;",
  "}",
  "",
  "char *float__ubn(char *charP, double input) {",
  "  char ch;",
  "  char *tempP;",
  "  char str[20];",
  "  int i;",
  "  int exp;",
  "  int trunc;",
  "  int digits;",
  "  long dividend;",
  "  long quotient;",
  "  long divisor;",
  "  float original;",
  "  str[1] = 0;",
  "  if (input<0)  strcpy(charP, \"-\");",
  "  else strcpy(charP, \" \");",
  "  if (input<0) input=-input;",
  "  exp = 0;",
  "  while (input>=1.0) {",
  "    exp++;",
  "    input = input/10.0;",
  "  }",
  "  if (input>100.0*DBL_MIN) {",
  "    while (input<0.1){",
  "      exp--;",
  "      input = input*10.0;",
  "    }",
  "    dividend = 1000000000.0*input+0.5;",
  "  }",
  "  else {dividend = 0; exp=1;}",
  "  digits = 0;",
  "  if (exp>-3 && exp<1) {",
  "    strcat(charP, \".\");",
  "    for (i=0; i>exp; i--) strcat(charP, \"0\");",
  "    digits=-1; exp=0;",
  "  }",
  "  else if (exp<10) {digits=exp; exp=0;}",
  "  else {digits=1; exp--;}",
  "  divisor = 100000000;",
  "  do {",
  "    if (!digits--) strcat(charP, \".\");",
  "    str[0] = dividend/divisor+'0';",
  "    strcat(charP,str);",
  "    dividend = dividend-dividend/divisor*divisor;",
  "    divisor=divisor/10;",
  "  }",
  "  while (dividend>1 || digits>0);",
  "  return charP;",
  "  if (digits>9) {",
  "    exp = digits-1;",
  "    digits = 1;",
  "  }",
  "  else if (digits<-3) {",
  "    exp = digits+1;",
  "    digits = 1;",
  "  }",
  "  else exp=0;",
  "  while (trunc-->0 || digits-->0) {",
  "    if (!digits)  strcat(charP, \".\");",
  "    ch = (int)dividend/10.0;",
  "    if (ch>9) ch=9;",
  "    dividend = dividend-(float)ch;",
  "    str[0] = ch+'0';",
  "    strcat(charP, str);",
  "  }",
  "  if (exp) {",
  "    tempP = str+20;",
  "    *--tempP = 0;",
  "    while (exp) {",
  "      *--tempP =  exp-exp/10+'0';",
  "      exp = exp/10;",
  "    }",
  "    *--tempP = 'E';",
  "    strcat(charP, tempP);",
  "  }",
  "}",
  "",      
  "",
  "~"
};

int main(int argc, char **argv) {
  char *mytemp;
  int intch;
  char eol;
  char *lineP;
  char *oldlineP;
  char ch;
  char *charP;
  char *tempP;
  char *phraseP;
  int returns=0;
  int fors=0;
  int forvar;
  int datac;
  int parens;
  char skiplf;
  char skipsemi = 0;
  char brace = 0;
  char eof;

  outfile = fopen(argv[argc-1], "w");
  infile = fopen(argv[1], "r");

  i=0;
  while (strcmp(before[i], "~"))  fprintf(outfile, "%s\n", before[i++]);

// remove multiple spaces
  inputP = input;
  intch = fgetc(infile);
  while (intch!=EOF) {
    eol = 0;
    while (!eol) { 
      while (intch==13)
        intch = fgetc(infile);
      if (intch==10 || intch==EOF) {
        while (*(inputP-1)==' ')  inputP--;
        *inputP++ = 0;
        if (intch!=EOF)
          intch = fgetc(infile);
        eol = 1;
      }
      else if (intch=='"'){
        do {
          *inputP++ = intch;
          intch = fgetc(infile);
        }
        while (intch!=EOF && intch!=10 && intch!='"');
        if (intch=='"') {  
          *inputP++ = intch;
          intch = fgetc(infile);
        }
      }
      else if (intch==' ' || intch=='\t') {
        *inputP++ = ' ';
        while (intch==' ' || intch=='\t')
          intch = fgetc(infile);
      }
      else {
        *inputP++ = intch;
        intch = fgetc(infile);
      }
    }
  }
  fclose(infile);
  strcat(inputP, "~");

// collect constants
  definedP = defineda;
  definedc = 0;
  definedv[0] = "";
  defining = 0;
  macroP = macro;
  *macroP = 0;
  labeling = 0;
  macroc = 0;
  inputP = input;
  linenumber = 0;
  while (strcmp(inputP, "~")) {
    lineP = inputP;
    linenumber++;
    if (listing)  printf("%d %s\n", linenumber, inputP);
    ch = lineP[11];
    lineP[11] = 0;
    if (!strcmp(lineP, "# CONSTANT ")) {
      inputP[11] = ch;
    if (listing)  printf("%d %s\n", linenumber, inputP+11);
      charP = getword(word1, inputP+11);
    if (listing)  printf("%d %s\n", linenumber, inputP+11);
      if (*(charP-1)=='$') {
        charP = getword(word2, charP);
        if (strcmp(word2, "="))  error("constant =");
        macrov[macroc++] = macroP;
        macroP = strcat(macroP, word1)+strlen(word1);
        *++macroP = 0;
        macroquote[macroc] = "\"";
        macrov[macroc++] = macroP;
        getword(word3, charP);
        if (!string || !constant)
          error("macro def not a string constant");
        fprintf(outfile, "#define %s %\"%s\"\n",
            macrov[macroc-2], macrov[macroc-1]);
      }
      else {
        charP = getword(word2, charP);
        if (strcmp(word2, "="))  error("missing =");
        getword(word3, charP);
        if (string)  error("string mismatch");
        macrov[macroc++] = macroP;
        macroP = strcat(macroP, word1)+strlen(word1);
        *++macroP = 0;
        macroquote[macroc] = "";
        macrov[macroc++] = macroP;
        wordP = word3;
        while (wordP[0]=='0' && strlen(wordP)>1)  wordP++;
        macroP = strcat(macroP, wordP)+strlen(wordP);
        *++macroP = 0;
      }
    }
    inputP[11] = ch;
    inputP = inputP+strlen(inputP)+1;
  }
  for (i=0; i<macroc; i=i+2)
    if (!strcmp(macroquote[i+1], ""))
      fprintf(outfile, "#define %s %s%s%s\n",
          macrov[i], macroquote[i+1], macrov[i+1], macroquote[i+1]);
  fprintf(outfile, "\n");

  constants = definedc;

// collect labels
  labeling = 1;
  labels = 0;
  dimming = 0;
  linenumber = 0;
  inputP = input;
  linenumber = 0;
  while (strcmp(inputP, "~")) {
    linenumber++;
    if (islabelchar(*inputP)) {
      getword(word1, inputP);
      if (keyword)  error("keyword as label");
    }
    inputP = inputP+strlen(inputP)+1;
  }

  labels = definedc;

//  for (i=0; i<definedc; i++)  printf("%s\n", definedv[i]);
//  printf("\n");

// define DIM's
  dimming = 1;
  labeling = 0;
  inputP = input;
  linenumber = 0;
  while (strcmp(inputP, "~")) {
    linenumber++;
    for (i=0; i<strlen(inputP); i++) {
      if (inputP[i]=='\"')
        while (input[i] && input[i]!='\"')  i++;
      if (inputP[i]=='\'') break;
      if (inputP[i]==' ' &&
          inputP[i+1]=='D' &&
          inputP[i+2]=='A' &&
          inputP[i+3]=='T' &&
          inputP[i+4]=='A' &&
          inputP[i+5]==' ')  break;
      if (inputP[i]==' ' &&
          inputP[i+1]=='R' &&
          inputP[i+2]=='E' &&
          inputP[i+3]=='M' &&
          inputP[i+4]==' ')  break;
      if (inputP[i]==' ' &&
          inputP[i+1]=='D' &&
          inputP[i+2]=='I' &&
          inputP[i+3]=='M' &&
          inputP[i+4]==' ') {
        charP = inputP+i+5;
        do {
          charP = getphrase(phrase1, charP);
          if (string)  fprintf(outfile, "char %s[300];\n", phrase1);
          else  fprintf(outfile, "double %s;\n", phrase1);
          while (*charP==' ')  charP++;
          if (*charP==',')  charP++;
        }
        while (*(charP-1)==',');
        i = i+charP-inputP;
      }
      if (inputP[i]==' ' &&
          inputP[i+1]=='P' &&
          inputP[i+2]=='R' &&
          inputP[i+3]=='I' &&
          inputP[i+4]=='N' &&
          inputP[i+5]=='T' &&
          inputP[i+6]==' ') {
        quote = 0;
        while (*lineP && !(*lineP==':' && !quote)) {
          if (*lineP=='\"')  quote=!quote;
          if (*lineP==':' && !quote)  break;
          if (*lineP)  lineP++;
        }
      }
      
    }
    inputP = inputP+strlen(inputP)+1;
  }

// define variables
  dimming = 0;
  variable0 = definedc;
  linenumber = 0;
  defining = 1;
  inputP = input;
  while (strcmp(inputP, "~")) {
    linenumber++;
    lineP = inputP;
    while (*lineP) {
      char quote;
      lineP=getword(word1, lineP);
      if (!strcmp(word1, "\'")) break;
      if (!strcmp(word1, "DATA"))  break;
      if (!strcmp(word1, "REM"))  break;
    }
    inputP = inputP+strlen(inputP)+1;
  }
  variables = definedc;

// collect data
  linenumber = 0;
  inputP = input;
  datac = 0;
  fprintf(outfile, "\nchar *datav__ubn[] = {\n  \"");
  while (1) {
    if (!strcmp(inputP, "~"))  break;
    linenumber++;
    lineP = inputP;
    while (*lineP) {
      lineP=getword(word1, lineP);
      if (!strcmp(word1, "REM"))  break;
      if (!strcmp(word1, "\'")) break;
      if (!strcmp(word1, "DATA")) {
        while (*lineP) {
          while (*lineP==' ')  lineP++;
          if (*lineP=='\"') {
            lineP++;
            while (*lineP && *lineP!='\"') {
              if (*lineP=='\\')  fprintf(outfile, "\\");
              if (*lineP=='\"')   break;
              else  fprintf(outfile, "%c", *lineP++);
            }
          }
          else  while (*lineP && *lineP!=',')
            fprintf(outfile, "%c", *lineP++);
          if (*lineP)  lineP++;
          fprintf(outfile, "\",\n  \"");
          datac++;
        }
      }
    }
    inputP = inputP+strlen(inputP)+1;
  }
  fprintf(outfile, "\"\n};\n\n");

// do code

  fprintf(outfile, "int main(int argc__ubn, char **ARGV_s_ubn) {\n");
  fprintf(outfile, "  float ARGC_f_ubn;\n");
  fprintf(outfile, "  ARGC_f_ubn = (float)argc__ubn;\n");
  fprintf(outfile, "  initscr();\n");
  fprintf(outfile, "  scrollok(stdscr, 1);\n");
  fprintf(outfile, "  printw(\"hello world\\n\");\n");
  fprintf(outfile, "  refresh(); getch();\n");
  fprintf(outfile, "  forP__ubn = for__ubn;\n");
  fprintf(outfile, "  returnP__ubn = return__ubn;\n");
  fprintf(outfile, "  datac__ubn = 0;\n");
  fprintf(outfile, "  for (i__ubn=0; i__ubn<256; i__ubn++) {\n");
  fprintf(outfile, "    chrs__ubn[i__ubn][0] = i__ubn;\n");
  fprintf(outfile, "    chrs__ubn[i__ubn][1] = 0;\n");
  fprintf(outfile, "  }\n");
  inputP = input;
  linenumber = 0;
  while (strcmp(inputP, "~")) {
    linenumber++;
    line = inputP;
    lineP = inputP;
    
    fromP = line;
    toP = qline;
    while (*fromP) {
      if (*fromP=='"' || *fromP=='\\')  *toP++ = '\\';
      *toP++ = *fromP++;
    }
    *toP = 0;
    
    if (listing)  printf("%d %s\n", linenumber, line);
    if (line[0]=='\'')  fprintf(outfile, "  /*%s*/", line+1);
    else {
      if ((line[0]>='A' && line[0]<='Z') || line[0]=='_' ||
          (line[0]>='a' && line[0]<='z')) {
        labelsdone++;
        lineP = getword(word3, lineP);
        fprintf(outfile, "%s:", word3);
        if (*lineP)  fprintf(outfile, "\n");
        else  skipsemi=1;
      }
      if (*qline)
        fprintf(outfile, "  if (tron)  fprintf(bug, \"\\n%d %s\") ;\n",
            linenumber,  qline);
      if (*line)  fprintf(outfile, "  line__ubn = %d;\n", linenumber);
      if (*lineP==' ') {
        fputc(*lineP++, outfile);
        fputc(' ', outfile);
        oldlineP = NULL;
        while (*lineP) {
          charP = getword(word1, lineP);
          if (!strcmp(word1, "PAUSE")) {
            fprintf(outfile, "getch()");
            lineP = charP;
          }
          else if (!strcmp(word1, "IF")) {
            fprintf(outfile, "if (");
            getword(word2, charP);
            do {
              lineP = getphrase(phrase1, charP);
              if (!lineP)  error("empty condition");
              lineP = getword(word1, lineP);
              if (!strcmp(word1, "="))  copyword("==", word1);
              if (!strcmp(word1, "<>"))  copyword("!=", word1);
              lineP = getphrase(phrase2, lineP);
              if (!strcmp(phrase2, "\"\\\""))  copyword("\"\\\\\"", phrase2);
              if (string)  fprintf(outfile, "strcmp(%s, %s)%s0",
                  phrase1, phrase2, word1);
              else if (*word1=='=')
                fprintf(outfile, "fabs(fabs(%s)-fabs(%s))<sf__ubn",
                    phrase1, phrase2);
              else if (*word1=='!')
                fprintf(outfile, "fabs(fabs(%s)-fabs(%s))>sf__ubn",
                    phrase1, phrase2);
              else fprintf(outfile, "%s%s%s", phrase1, word1, phrase2);
              charP = getword(word1, lineP);
              if (!strcmp(word1, "+") || !strcmp(word1, "-")) {
                lineP = getphrase(phrase1, charP);
                if (!lineP)  error("bad if");
                fprintf(outfile, " %s %s", word1, phrase1);
                charP = getword(word1, lineP);
              }
              if (!strcmp(word1, "AND"))  fprintf(outfile, " && ");
              if (!strcmp(word1, "OR"))  fprintf(outfile, " || ");
            }
            while (!strcmp(word1, "AND") || !strcmp(word1, "OR"));
            fprintf(outfile, ") {");
            brace = 1;
            if (!strcmp(word1, "THEN"))  lineP = charP;
          }
          else if (!strcmp(word1, "ELSE")) {
            if (!brace)  error("stray ELSE");
            fprintf(outfile, ";}\n  else {");
            lineP = charP;
          }
          else if (!strcmp(word1, "GOTO")) {
            fprintf(outfile, "goto ");
            lineP = charP;
            lineP = copylabel(outfile, lineP);
          }
          else if (!strcmp(word1, ":")) {
            fprintf(outfile, "; ");
            lineP = charP;
          }
          else if (!strcmp(word1, "RETURN")) {
            fprintf(outfile, "goto returns__ubn");
            lineP = charP;
          }
          else if (!strcmp(word1, "GOSUB")) {
            fprintf(outfile, "*forP__ubn++=-1; ");
            fprintf(outfile, "*returnP__ubn++=%d; ", returns);
            fprintf(outfile, "goto ");
            lineP = charP;
            lineP = copylabel(outfile, lineP);
            fprintf(outfile, ";\nreturn%d__ubn:", returns++);
            if (*lineP) {
              fprintf(outfile, "\n  ");
              lineP = getword(word1, lineP);
              if (strcmp(word1, ":"))  error("not a colon");
            }
            else  skipsemi=1;
          }
          else if (!strcmp(word1, "REM") || !strcmp(word1, "\'")) {
            lineP = charP;
            if (*lineP)  fprintf(outfile, " /*%s*/", lineP);
            lineP = lineP+strlen(lineP);
          }
          else if (!strcmp(word1, "STOP")) {
            fprintf(outfile, "refresh(); getch()");
            lineP = charP;
          }
          else if (!strcmp(word1, "PAUSE")) {
            fprintf(outfile, "getch()");
            lineP = charP;
          }
          else if (!strcmp(word1, "NEXT")) {
            lineP = charP;
            charP = getword(word2, charP);
            if (variable) {
              for (i=variable0; i<variables; i++)
                if (strcmp(word2, definedv[i]))  break;
              if (i>=variables)  error("next forvar");
              forvar = i;
              lineP = charP;
            }
            else  forvar = 0;
            fprintf(outfile, "forvar__ubn=%d; ", forvar);
            fprintf(outfile, "back__ubn=%d; ", returns);
            fprintf(outfile, "goto next__ubn;\n");
            fprintf(outfile, "return%d__ubn:", returns++);
            if (*lineP) {
              fprintf(outfile, "\n  ");
              lineP = getword(word1, lineP);
              if (strcmp(word1, ":"))  error("not a colon");
            }
            else  skipsemi=1;
          }
          else if (!strcmp(word1, "PRINT")) {
            lineP = charP;
            charP = getword(word1, lineP);
            if (!strcmp(word1, "@")) {
              atflag = 1;
              fprintf(outfile, "P__ubn=.2+");
              lineP = getphrase(phrase1, charP);
              fprintf(outfile, phrase1);
              fprintf(outfile, ";\n");
              fprintf(outfile, "  move(P__ubn/32, P__ubn-P__ubn/32*32);\n  ");
              strcpy(phrase1, "printw(");
              charP = getword(word2, lineP);
              if (*lineP && strcmp(word2, ",") && strcmp(word2, ":")
                && strcmp(word2, "\'") && strcmp(word2, "REM"))
                error("missing ,");
              if (!strcmp(word2, ","))  lineP=charP;
            }
            else if (!strcmp(word1, "#")) {
              lineP = getphrase(phrase2, charP);
              phraseP = copyword("  fprintf(file__ubn[", phrase1);
              phraseP = copyword(phrase2, phraseP);
              phraseP = copyword("], ", phraseP);
              charP = getword(word2, lineP);
              if (*lineP && strcmp(word2, ",") && strcmp(word2, ":")
                  && strcmp(word2, "\'") && strcmp(word2, "REM"))
                error("missing ,");
              if (!strcmp(word2, ","))  lineP=charP;
            }
            else {
              strcpy(phrase1, "printw(");
              atflag = 0;
            }
            charP = getword(word2, lineP);
            while (*lineP && strcmp(word2, "REM") && strcmp(word2, "\'")
                && strcmp(word2, ":")) {
              lineP = getphrase(phrase2, lineP);
              if (string)  fprintf(outfile, "%s%s)", phrase1, phrase2);
              else {
                fprintf(outfile, "dend__ubn=%s;\n", phrase2);
                fprintf(outfile, "  if (fabs(fabs(round__ubn(dend__ubn))-");
                fprintf(outfile, "fabs(dend__ubn))<.0000001)\n");
                fprintf(outfile, "    %s\" %cd \",", phrase1, '%');
                fprintf(outfile, " round__ubn(dend__ubn));\n    ");
                fprintf(outfile, "%s\"%cs\",float__ubn(phrase__ubn,%s))",
                    phrase1, '%', phrase2);
              }
              tempP = lineP;
              charP = getword(word2, lineP);
              skiplf = 0;
              while (!strcmp(word2, ";")) {
                skiplf = 1;
                lineP = charP;
                charP = getword(word2, lineP);
              }
              if (*lineP && strcmp(word2, "REM") && strcmp(word2, "\'")
                  && strcmp(word2, ":"))
                fprintf(outfile, ";\n  ");
            }
            if (!skiplf)  fprintf(outfile, ";\n  %s\"\\n\")", phrase1);
            if (!strcmp(phrase1, "printw(") )
              fprintf(outfile, ";\n  refresh()");
          }
          else if (!strcmp(word1, "FOR")) {
            if (!(charP = getword(word1, charP)))  error("FOR variable");
            if (string)  error("string for FOR variable");
            if (!(charP = getword(word3, charP)))  error("FOR =");
            if (strcmp(word3, "="))  error("FOR =");
            if (!(charP = getphrase(phrase1, charP)))  error("FOR = start");
            if (string)  error("string FOR variable phrase");
            if (!(charP = getword(word3, charP)))  error("FOR stop");
            if (strcmp(word3, "TO"))  error("FOR TO");
            strcpy(phrase2, "(float)(");
            charP = getphrase(phrase2+strlen(phrase2), charP);
            strcat(phrase2, ")");
            if (string)  error("string FOR variable phrase");
            for (i=variable0; i<variables; i++)
              if (!strcmp(word1, definedv[i]))  break;
            if (i>=variables)  error("for forvar");
            forvar = i;
            if (*charP) {
              charP = getword(word3, charP);
              if (!strcmp(word3, "STEP")) {
                if (!*charP)  error("STEP");
                strcpy(phrase3, "(float)(");
                charP = getphrase(phrase3+strlen(phrase3), charP);
                strcat(phrase3, ")");
              }
              else if (strcmp(word3, ":"))  error("not :");
              else  strcpy(phrase3, "1.0");
            }
            else  strcpy(phrase3, "1.0");

            lineP = charP;
            fprintf(outfile, "%s=%s;", word1, phrase1);
            fprintf(outfile, " *forP__ubn++=%d;", forvar);
            fprintf(outfile, " *returnP__ubn++=%d;\n", returns);
            fprintf(outfile, "  to__ubn[%d]=%s;", fors, phrase2);
            fprintf(outfile, " step__ubn[%d]=%s;", fors, phrase3);
            fprintf(outfile, " goto for__ubn%d;\n", fors);
            fprintf(outfile, "return%d__ubn:\n", returns++);
            fprintf(outfile, "  %s=%s+step__ubn[%d];\n", word1, word1, fors);
            fprintf(outfile, "  if (step__ubn[%d]>0 &&", fors);
            fprintf(outfile, " %s>to__ubn[%d])", word1, fors);
            fprintf(outfile, " goto forgone__ubn;\n");
            fprintf(outfile, "  if (step__ubn[%d]==0 &&", fors);
            fprintf(outfile, " fabs(fabs(%s)-fabs(", word1);
            fprintf(outfile, "to__ubn[%d]))<sf__ubn)", fors);
            fprintf(outfile, " goto forgone__ubn;\n");
            fprintf(outfile, "  if (step__ubn[%d]<0 &&", fors);
            fprintf(outfile, " %s<to__ubn[%d])", word1, fors);
            fprintf(outfile, " goto forgone__ubn;\n");
            fprintf(outfile, "for__ubn%d:", fors++);
            if (*lineP) {
              fprintf(outfile, "\n  ");
              lineP = getword(word1, lineP);
              if (strcmp(word1, ":"))  error("not a colon");
            }
            else  skipsemi=1;
          }
          else if (!strcmp(word1, "LINE")) {
            lineP = getword(word2, charP);
            if (!strcmp(word2, "INPUT")) {
              getword(word1, lineP);
              if (!strcmp(word1, "#")) {
                lineP = getword(word1, lineP);
                lineP = getphrase(phrase1, lineP);
                if (string)  error("string file number");
                lineP = getword(word1, lineP);
                if (strcmp(word1, ","))  error("missing ,");
              }
              else  strcpy(phrase1, "0");
              lineP = getphrase(phrase2, lineP);
              fprintf(outfile, "lineinput__ubn(%s, %s);",
                  phrase1, phrase2);
            }
          }
          else if (!strcmp(word1, "ON")) {
            lineP = getphrase(phrase1, charP);
            fprintf(outfile, "switch(index__ubn(%s)) {\n", phrase1);
            charP = getword(word1, lineP);
            if (strcmp(word1, "GOTO") && strcmp(word1,"GOSUB"))
              error("GOTO or GOSUB please");
            if (!strcmp(word1, "GOTO")) {
              i = 1;
              do {
                charP = getword(word2, charP);
                if (!label)  error("label please");
                fprintf(outfile, "    case %d: goto %s;\n", i++, word2);
                lineP = charP;
                charP = getword(word1, lineP);
              }
              while (!strcmp(word1, ","));
              fprintf(outfile, "  }\n");
            }
            else  error ("on gosub later");
            lineP = charP;
          }
          else if (!strcmp(word1, "DATA")) {
            lineP = lineP+strlen(lineP);
            skipsemi = 1;
          }
          else if (!strcmp(word1, "DIM") || !strcmp(word1, "CLEAR") ||
              !strcmp(word1, "FILES") || !strcmp(word1, "PCLEAR")) {
            lineP = skip2colon(charP);
            skipsemi = 1;
          }
          else if (!strcmp(word1, "READ")) {
            lineP = getphrase(phrase1, charP);
            fprintf(outfile, "i__ubn=0; ");
            fprintf(outfile, "while ((%s[i__ubn] = ", phrase1);
            fprintf(outfile, "datav__ubn[datac__ubn][i__ubn]))"),
            fprintf(outfile, "  i__ubn++; datac__ubn++");
          }
          else if (!strcmp(word1, "CLOSE")) {
            lineP = getword(word2, charP);
            if (!strcmp(word2, "FILE_I") || !strcmp(word2, "NUM_1"))
              copyword("file_i", word2);
            else if (!strcmp(word2, "FILE_O") || !strcmp(word2, "NUM_2"))
              copyword("file_o", word2);
            else if (!strcmp(word2, "FILE_X")) {
              fprintf(outfile, "  if(!ERRORS && !WARNINGS && quiet)  ");
              fprintf(outfile, "printf(\"[no errors]\\n\") ;\n");
            }
            else {
//          fprintf(outfile, "// CLOSE %s", word2);
              skipsemi = 1;
            }
            if (!strcmp(word2, "file_i") || !strcmp(word2, "file_o"))
              fprintf(outfile, "fclose(%s)", word2);
          }
          else if (!strcmp(word1, "OPEN")) {
            charP = getword(word1, charP);
            if (!strcmp(word1, "\"I\"") || !strcmp(word1, "\"i\""))
              getword(word1, "\"r\"");
            else if (!strcmp(word1, "\"O\"") || !strcmp(word1, "\"o\""))
              getword(word1, "\"w\"");
            else  error("I or i or O or o please");
            charP = getword(word2, charP);
            if (strcmp(word2, ","))  error("missing ,");
            charP = getphrase(word2, charP);
            if (!strcmp(word2, "#"))  charP = getphrase(word2, charP);
            if (string)  error("string file number");
            charP = getword(word3, charP);
            if (strcmp(word3, ","))  error("missing ,");
            lineP = getphrase(phrase3, charP);
            if (!string)  error("file name not string");
            fprintf(outfile, "file__ubn[index__ubn(%s)] = fopen(%s, %s);\n",
                word2, phrase3, word1);
            fprintf(outfile, "  if (!file__ubn[index__ubn(%s)])");
            fprintf(outfile, "  error__ubn(\"bad name\", line__ubn)");
          }
          else if (!strcmp(word1, "END")) {
            fprintf(outfile, "refresh(); getch();\n");
            fprintf(outfile, "  for(i__ubn=0; i__ubn<26; i__ubn++)");
            fprintf(outfile, " printw(\"\\n\");\n");
            fprintf(outfile, "  refresh(); endwin(); exit(0)");
            lineP = charP;
          }
          else if (!strcmp(word1, "CLS")) {
            fprintf(outfile, "clear(); refresh();");
            lineP = charP;
          }
          else {
            charP = lvalphrase(phrase1, lineP);
            if (string) {
              charP = getword(word2, charP);
              if (strcmp(word2, "="))  error("=");
              lineP = stringphrase(phrase2, charP);
              if (!string)  error("not string");
              if (*lineP) {
                charP = getword(word3, lineP);
                if (!strcmp(word3, "+")) {
                  lineP = getphrase(phrase3, charP);
                  fprintf(outfile, "  join(%s, %s, %s);\n",                    
                      phrase1, phrase2, phrase3);
                  if (*lineP && *lineP!=':')  error("not a :");
                }
                else if (!strcmp(word3, ":") || !strcmp(word3, "ELSE"))
                  fprintf(outfile, "let__ubn(%s, %s)", phrase1, phrase2);
              }
              else {
                fprintf(outfile, "let__ubn(%s, %s)", phrase1, phrase2);
              }
            }
            else {
              fprintf(outfile, "%s", phrase1);
              lineP = getword(word2, charP);
              if (strcmp(word2, "="))  error("=");
              lineP = numberphrase(phrase1, lineP);
              fprintf(outfile, "=%s", phrase1);
            }
          }
          if (lineP==oldlineP)  error("stuck");
          oldlineP = lineP;
        }
        if (!(!strcmp(word1, "REM") || skipsemi || !strcmp(word2, "\'") ||
             !strcmp(word1, "FOR") || !strcmp(word1, "GOSUB")))
          fprintf(outfile, ";");
        skipsemi = 0;
        if (brace)  fprintf(outfile, "}");
        brace = 0;
      }
    }
    fputc(10, outfile);
    inputP = inputP+strlen(inputP)+1;
  }
  fputc(10, outfile);
  for (i=labelsdone+constants; i<labels; i++)
    fprintf(outfile, "%s:\n", definedv[i]);

  char *last[] = {
    "next__ubn:",
    "  while (1) {",
    "    if (*(forP__ubn-1)==forvar__ubn) break;",
    "    if (*(forP__ubn-1)<0)",
    "\"next without for\"",
    "    if (forvar__ubn==0)  break;",
    "    forP__ubn--;",
    "    returnP__ubn--;",
    "    if (forP__ubn==fora__ubn)",
    "\"next without for\"",
    "  }",
    "  switcher__ubn = *(returnP__ubn-1);",
    "  goto switching__ubn;",
    "",
    "forgone__ubn:",
    "  forP__ubn--; returnP__ubn--; switcher__ubn=back__ubn; goto switching__ubn;",
    "",
    "returns__ubn:",
    "  if (forP__ubn<=fora__ubn) {",
    "    for (tempP__ubn=returnP__ubn; tempP__ubn<returnP__ubn+20; tempP__ubn++)",
    "      printf(\"\\n%d\", *tempP__ubn);",
    "\"return without gosub\"",
    "  }",
    "  while (forP__ubn>fora__ubn) {",
    "    forP__ubn--;",
    "    returnP__ubn--;",
    "    if (*forP__ubn<0) break;",
    "  }",
    "  if(*forP__ubn>=0) {",
    "    for (tempP__ubn=forP__ubn; tempP__ubn<forP__ubn+20; tempP__ubn++)",
    "      printf(\"%d\\n\", *tempP__ubn);",
    "\"return without gosub\"",
    "  }",
    "  switcher__ubn = *returnP__ubn;",
    "  goto switching__ubn;",
    "",
    "switching__ubn:",
    "  switch(switcher__ubn) {",
    "~"
  };

  i = 0;
  while (strcmp(last[i], "~")) {
    if (last[i][0]=='\"')
      fprintf(outfile, "    error__ubn(%s, line__ubn);\n", last[i++]);
    else  fprintf(outfile, "%s\n", last[i++]);
  }

  for (i=0; i<returns; i++) {
    fprintf(outfile, "    case %d: goto return%d__ubn;\n", i, i);
  }

  fprintf(outfile, "  }\n");
  fprintf(outfile, "  refresh();\n");
  fprintf(outfile, "  getch();\n");
  fprintf(outfile, "  endwin();\n");
  fprintf(outfile, "  exit(0);\n");
  fprintf(outfile, "}\n");
  fclose(outfile);

  return 0;
}
